
/* Pedmt: Algoritmy (IAL) - FIT VUT v Brn
 * Hlavikov soubor pro c206.c (Dvousmrn vzan linern seznam)
 * Vytvoil: Martin Tuek, z 2005
 * Upravil: Bohuslav Kena, jen 2008
 *  
 *  Tento soubor, prosme, neupravujte!  
 */

#include<stdio.h>
#include<stdlib.h>

#define FALSE 0
#define TRUE 1

extern int errflg;
extern int solved;
 
typedef struct tDLElem {                /* prvek dvouosmrn vzanho seznamu */ 
        int data;                                            /* uiten data */
        struct tDLElem *lptr;          /* ukazatel na pedchoz prvek seznamu */
        struct tDLElem *rptr;        /* ukazatel na nsledujc prvek seznamu */
} *tDLElemPtr;

typedef struct {                                  /* dvousmrn vzan seznam */
    tDLElemPtr First;                      /* ukazatel na prvn prvek seznamu */
    tDLElemPtr Act;                     /* ukazatel na aktuln prvek seznamu */
    tDLElemPtr Last;                    /* ukazatel na posledni prvek seznamu */
} tDLList;

                                             /* prototypy jednotlivch funkc */
void DLInitList (tDLList *);
void DLDisposeList (tDLList *);
void DLInsertFirst (tDLList *, int);
void DLInsertLast(tDLList *, int);
void DLFirst (tDLList *);
void DLLast (tDLList *);
void DLCopyFirst (tDLList *, int *);
void DLCopyLast (tDLList *, int *);
void DLDeleteFirst (tDLList *);
void DLDeleteLast (tDLList *);
void DLPostDelete (tDLList *);
void DLPreDelete (tDLList *);
void DLPostInsert (tDLList *, int);
void DLPreInsert (tDLList *, int);
void DLCopy (tDLList *, int *);
void DLActualize (tDLList *, int);
void DLSucc (tDLList *);
void DLPred (tDLList *);
int DLActive (tDLList *);

